part of trober_sdk.api;

// User
class User {
  String id;

  DateTime createdAt;

  DateTime updatedAt;

  String createdBy;

  String tenantId;

  String customerId;

  String name;

  String username;

  String email;

  String deviceId;

  UserRole role;
  User();

  @override
  String toString() {
    return 'User[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, customerId=$customerId, name=$name, username=$username, email=$email, deviceId=$deviceId, role=$role, ]';
  }

  fromJson(Map<String, dynamic> json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      id = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'created_at'];
      createdAt = (_jsonData == null) ? null : DateTime.parse(_jsonData);
    } // _jsonFieldName
    {
      final _jsonData = json[r'updated_at'];
      updatedAt = (_jsonData == null) ? null : DateTime.parse(_jsonData);
    } // _jsonFieldName
    {
      final _jsonData = json[r'created_by'];
      createdBy = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'tenant_id'];
      tenantId = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'customer_id'];
      customerId = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'name'];
      name = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'username'];
      username = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'email'];
      email = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'device_id'];
      deviceId = (_jsonData == null) ? null : _jsonData;
    } // _jsonFieldName
    {
      final _jsonData = json[r'role'];
      role = (_jsonData == null)
          ? null
          : UserRoleTypeTransformer.fromJson(_jsonData);
    } // _jsonFieldName
  }

  User.fromJson(Map<String, dynamic> json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    if (id != null) {
      json[r'id'] = LocalApiClient.serialize(id);
    }
    if (createdAt != null) {
      json[r'created_at'] = createdAt.toUtc().toIso8601String();
    }
    if (updatedAt != null) {
      json[r'updated_at'] = updatedAt.toUtc().toIso8601String();
    }
    if (createdBy != null) {
      json[r'created_by'] = LocalApiClient.serialize(createdBy);
    }
    if (tenantId != null) {
      json[r'tenant_id'] = LocalApiClient.serialize(tenantId);
    }
    if (customerId != null) {
      json[r'customer_id'] = LocalApiClient.serialize(customerId);
    }
    if (name != null) {
      json[r'name'] = LocalApiClient.serialize(name);
    }
    if (username != null) {
      json[r'username'] = LocalApiClient.serialize(username);
    }
    if (email != null) {
      json[r'email'] = LocalApiClient.serialize(email);
    }
    if (deviceId != null) {
      json[r'device_id'] = LocalApiClient.serialize(deviceId);
    }
    if (role != null) {
      json[r'role'] = LocalApiClient.serialize(role);
    }
    return json;
  }

  static List<User> listFromJson(List<dynamic> json) {
    return json == null
        ? <User>[]
        : json.map((value) => User.fromJson(value)).toList();
  }

  static Map<String, User> mapFromJson(Map<String, dynamic> json) {
    final map = <String, User>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = User.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is User && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          customerId == other.customerId &&
          name == other.name &&
          username == other.username &&
          email == other.email &&
          deviceId == other.deviceId &&
          role == other.role;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    if (id != null) {
      hashCode = hashCode ^ id.hashCode;
    }

    if (createdAt != null) {
      hashCode = hashCode ^ createdAt.hashCode;
    }

    if (updatedAt != null) {
      hashCode = hashCode ^ updatedAt.hashCode;
    }

    if (createdBy != null) {
      hashCode = hashCode ^ createdBy.hashCode;
    }

    if (tenantId != null) {
      hashCode = hashCode ^ tenantId.hashCode;
    }

    if (customerId != null) {
      hashCode = hashCode ^ customerId.hashCode;
    }

    if (name != null) {
      hashCode = hashCode ^ name.hashCode;
    }

    if (username != null) {
      hashCode = hashCode ^ username.hashCode;
    }

    if (email != null) {
      hashCode = hashCode ^ email.hashCode;
    }

    if (deviceId != null) {
      hashCode = hashCode ^ deviceId.hashCode;
    }

    if (role != null) {
      hashCode = hashCode ^ role.hashCode;
    }

    return hashCode;
  }

  User copyWith({
    String id,
    DateTime createdAt,
    DateTime updatedAt,
    String createdBy,
    String tenantId,
    String customerId,
    String name,
    String username,
    String email,
    String deviceId,
    UserRole role,
  }) {
    User copy = User();
    copy.id = id ?? this.id;
    copy.createdAt = createdAt ?? this.createdAt;
    copy.updatedAt = updatedAt ?? this.updatedAt;
    copy.createdBy = createdBy ?? this.createdBy;
    copy.tenantId = tenantId ?? this.tenantId;
    copy.customerId = customerId ?? this.customerId;
    copy.name = name ?? this.name;
    copy.username = username ?? this.username;
    copy.email = email ?? this.email;
    copy.deviceId = deviceId ?? this.deviceId;
    copy.role = role ?? this.role;
    return copy;
  }
}
